package rocks.zipcode.io.quiz3.arrays;

import java.util.ArrayList;
import java.util.Arrays;

/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {

    String[][] board;
    String[] row;
    String[] column;

    public TicTacToe(String[][] board) {
        this.board = board;
    }

    public String[] getRow(Integer value) {

       row = board[value];

        return row;
    }

    public String[] getColumn(Integer value) {
        ArrayList list = new ArrayList();
        for(int i =0; i< board.length; i++){
            list.add(board[i][value]);

        }
        Object[] columnObj = list.toArray();

        column = Arrays.copyOf(columnObj,columnObj.length, String[].class);
        return column;
    }

    public Boolean isRowHomogenous(Integer rowIndex) {

        String[] newRow = getRow(rowIndex);

        String check = newRow[0];
        for(int i = 0; i< newRow.length; i++){
                if(check != newRow[i]){
                    return false;
                }
        }



        return true;
    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {

        String[] newColumn = getColumn(columnIndex);

        String check = newColumn[0];

        for(int i = 0; i < newColumn.length; i++){
            if(check != newColumn[i]){
                return false;
            }
        }

        return true;
    }

    public String getWinner() {

        for(int i = 0; i < board.length; i++) {
            if (isColumnHomogeneous(i)){
                return column[i];
            } else if(isRowHomogenous(i)){
                return row[i];
            }
        }

        return null;
    }
}
